//Подключение библиотеки I2C шины.
#include <Wire.h>
//Побключение библиотеки управления моторами.
#include "motor.h"
//Подключение библиотеки управления гироскопом.
//#include "gyro_acsel.h"
//Подключение библиотеки обработки цветов.
#include "memcolor.h"
#include "sonar.h"

#define LBL A6 //Пины выведены на Arduino nano, но не всегда выведены на UNO.
#define RBL A7 // Эти пины можно использовать только для чтения.

void yellow_8(float aaa);
void red_8(float aaa);
int L_line_l, R_line_l; //Черная линия

//========================================
void setup()
{
  //pinMode(LBL, INPUT);
  //pinMode(RBL, INPUT);


  pinMode(12, OUTPUT);
  digitalWrite(12, HIGH);

  Serial.begin(115200);
  Sonar_init(11, 10);
  //запуск гироскопа.
  //  migate(3, 20);
  apds9960_setup();
  // giroscop_setup();

  // Переменные – номера контактов (пинов) Arduino.
  // Для левых и правых моторов машинки.
  setup_motor_system(5, 4, 2, 3);
  _stop(); //Двигатели остановлены.
  Serial.print(" Start ");
  digitalWrite(12, LOW);
  pinMode(A0, INPUT);
  digitalWrite(A0, HIGH);
}
// Основная программа.
void loop()
{
  int knopka;
  knopka = knopka_read(); //ждем нажатия кнопока, код нажатия от 1 до 4 слева направо по ряду кнопок
  migate(knopka, 5); //количество мигов и частота
  delay(500);
  if (knopka == 1) //Если нажата кнопка 1 то производим запоминание баночек
  {
    knopka = knopka_read(); //ждем нажатия кнопока, код нажатия от 1 до 4 слева направо по ряду кнопок
    migate(knopka, 100); //количество мигов и частота
    switch (knopka)
    {
      case 2:
        digitalWrite(12, HIGH);
        for (int i = 0; i < 100; i++) {
          foto_yellow();
          delay(50);
        }
        digitalWrite(12, LOW);
        //migate(5, 10); //количество мигов и частота
        break;
      case 3:
        digitalWrite(12, HIGH);
        for (int i = 0; i < 100; i++) {
          foto_red();
          delay(50);
        }
        digitalWrite(12, LOW);
        //migate(5, 10); //количество мигов и частота
        break;
      case 4:
        write_color_data_eeprom();
        migate(15, 10); //количество мигов и частота
        break;
    }
    return;
  }
  else if (knopka == 4)
  {
    //migate(knopka, 50); //количество мигов и частота
    knopka = knopka_read(); //ждем нажатия кнопока, код нажатия от 1 до 4 слева направо по ряду кнопок
    migate(knopka, 100); //количество мигов и частота
    switch (knopka)
    {
      case 2:
        yellow_8(0);
        break;
      case 3:
        red_8(0);
        break;
      case 4:
        break;
    }
  }
  return;
}
//===========================
//===========================
void yellow_8(float aaa)
{
  int dist = 100, f;
  int steps;
  bool banka;
  banka = false;

  dist = Sonar(40);
  while (dist < 35)
  {
    right();
    delay(5);
    _stop();
    delay(10);
    dist = Sonar(45);
  }
  while (true)
  {
    while (dist > 35)
    {
      left();
      delay(5);
      _stop();
      delay(10);
      dist = Sonar(45);
    }
    int step_tik = 0;
    while (dist < 35)
    {
      left();
      delay(5);
      _stop();
      delay(10);
      dist = Sonar(45);
      step_tik++;
    }
    delay(80);
    step_tik /= 2;
    for (f = 0; f < step_tik; f++)
    {
      right();
      delay(5);
      _stop();
      delay(10);
      dist = Sonar(45);
    }
    delay(80);
    dist = Sonar(45);
    if (dist < 35)
    {
      steps = 0;
      while ((dist > 5) && (!black_line()) && (steps < 50))
      {
        forward();
        delay(5);
        _stop();
        delay(10);
        dist = Sonar(45);
        steps++;
      }

      // == Здесь выпрямляем робота
      vipryamlenie();
      //================

      apds.readProximity(proximity_data);
      delay(80);
      int step_tik2 = 0;
      while ((proximity_data < 200) && (step_tik2 < 20))
      {
        right();
        delay(5);
        _stop();
        delay(10);
        apds.readProximity(proximity_data);
        step_tik2++;
      }
      step_tik2 = 0;
      while ((proximity_data < 200) && (step_tik2 > -20))
      {
        left();
        delay(5);
        _stop();
        delay(10);
        apds.readProximity(proximity_data);
        step_tik2--;
      }
      if (proximity_data > 200)
      {

        if (test_yellow())
        {
          banka = true;
          while (!black_line())
          {
            forward();
            delay(5);
            _stop();
            delay(10);
            dist = Sonar(45);
            steps++;
          }
          // == Здесь выпрямляем робота
          vipryamlenie();
          //================
          while (black_line())
          {
            forward();
            delay(5);
            _stop();
            delay(10);
            dist = Sonar(45);
            steps++;
          }
        }
      }
      else
      {
        while ((step_tik2 < 0))
        {
          right();
          delay(5);
          _stop();
          delay(10);
          apds.readProximity(proximity_data);
          step_tik2++;
        }
      }
      if (!banka)
      {
        while (steps > 0 )
        {
          backward();
          delay(5);
          _stop();
          delay(10);
          dist = Sonar(45);
          steps--;
        }
      }
      else
      {
        from_line_to_center();
        banka = false;
      }
    }
    for (f = 0; f < (step_tik + 12); f++)
    {
      left();
      delay(5);
      _stop();
      delay(10);
    }
    dist = Sonar(45);
  }
}
//===========================
//===========================
void red_8(float aaa)
{
  int dist = 100, f;
  int steps;
  bool banka;
  banka = false;

  dist = Sonar(40);
  while (dist < 35)
  {
    right();
    delay(5);
    _stop();
    delay(10);
    dist = Sonar(45);
  }
  while (true)
  {
    while (dist > 35)
    {
      left();
      delay(5);
      _stop();
      delay(10);
      dist = Sonar(45);
    }
    int step_tik = 0;
    while (dist < 35)
    {
      left();
      delay(5);
      _stop();
      delay(10);
      dist = Sonar(45);
      step_tik++;
    }
    delay(80);
    step_tik /= 2;
    for (f = 0; f < step_tik; f++)
    {
      right();
      delay(5);
      _stop();
      delay(10);
      dist = Sonar(45);
    }
    delay(80);
    dist = Sonar(45);
    if (dist < 35)
    {
      steps = 0;
      while ((dist > 5) && (!black_line()) && (steps < 50))
      {
        forward();
        delay(5);
        _stop();
        delay(10);
        dist = Sonar(45);
        steps++;
      }
      // == Здесь выпрямляем робота
      vipryamlenie();
      //================
      apds.readProximity(proximity_data);
      delay(80);
      int step_tik2 = 0;
      while ((proximity_data < 200) && (step_tik2 < 20))
      {
        right();
        delay(5);
        _stop();
        delay(10);
        apds.readProximity(proximity_data);
        step_tik2++;
      }
      step_tik2 = 0;
      while ((proximity_data < 200) && (step_tik2 > -20))
      {
        left();
        delay(5);
        _stop();
        delay(10);
        apds.readProximity(proximity_data);
        step_tik2--;
      }
      if (proximity_data > 200)
      {
        if ( test_red())
        {
          banka = true;
          while (!black_line())
          {
            forward();
            delay(5);
            _stop();
            delay(10);
            dist = Sonar(45);
            steps++;
          }
          // Здесь подвернуть
          vipryamlenie();
          //==============
          while (black_line())
          {
            forward();
            delay(5);
            _stop();
            delay(10);
            dist = Sonar(45);
            steps++;
          }
        }
      }
      else
      {
        while ((step_tik2 < 0))
        {
          right();
          delay(5);
          _stop();
          delay(10);
          apds.readProximity(proximity_data);
          step_tik2++;
        }
      }
      if (!banka)
      {
        while (steps > 0 )
        {
          backward();
          delay(5);
          _stop();
          delay(10);
          dist = Sonar(45);
          steps--;
        }
      }
      else
      {
        from_line_to_center();
        banka = false;
      }
    }
    for (f = 0; f < (step_tik + 12); f++)
    {
      left();
      delay(5);
      _stop();
      delay(10);
    }
    dist = Sonar(45);
  }
}
//===========================
//=================================
void migate(int n, int freq)
{
  freq = 500 / freq;
  for (int i = 0; i < n; i++)
  {
    digitalWrite(12, HIGH);
    delay(freq);
    digitalWrite(12, LOW);
    delay(freq);
  }
}
//=====================================
int knopka_read()
{
  int knopka;
  do
  {
    delay(50);
    knopka = analogRead(A0);

    //  Serial.println(knopka);

    if (knopka < 25) knopka = 1;
    else if (knopka < 100) knopka = 4;
    else if (knopka < 150) knopka = 3;
    else if (knopka < 350) knopka = 2;
  }
  while (knopka > 5);
  return knopka;
}
//=====================================
bool black_line()
{
  L_line_l = analogRead(LBL);
  R_line_l = analogRead(RBL);
  if ( (  L_line_l > 240) || (R_line_l > 240))
    return true;
  else
    return false;
}
//=====================================
//Выпрямляем робота
void vipryamlenie()
{
  if ((L_line_l > 240) && (R_line_l < 240))
  {
    while ((L_line_l > 240) && (R_line_l < 240))
    {
      right();
      delay(5);
      _stop();
      delay(10);
      black_line();
    }
  }
  else if ((L_line_l < 240) && (R_line_l > 240))
  {
    while ((L_line_l < 240) && (R_line_l > 240))
    {
      left();
      delay(5);
      _stop();
      delay(10);
      black_line();
    }
  }
}
//=====================================
void from_line_to_center() // от черной линии к центру
{
  for (int f = 0; f < 130; f++)
  {
    backward();
    delay(5);
    _stop();
    delay(10);
    Sonar(45);
  }
}

