#include <EEPROM.h>
// Датчик цвета
#include "SparkFun_APDS9960.h"

// Global Variables
SparkFun_APDS9960 apds = SparkFun_APDS9960();
uint16_t ambient_light = 0;
uint16_t red_light = 0;
uint16_t green_light = 0;
uint16_t blue_light = 0;
uint8_t proximity_data = 0;

byte Y_max_mass_red_light;
byte Y_min_mass_red_light;
byte Y_max_mass_green_light;
byte Y_min_mass_green_light;
byte Y_max_mass_blue_light;
byte Y_min_mass_blue_light;

byte R_max_mass_red_light;
byte R_min_mass_red_light;
byte R_max_mass_green_light;
byte R_min_mass_green_light;
byte R_max_mass_blue_light;
byte R_min_mass_blue_light;

byte mass_red_light;
byte mass_green_light;
byte mass_blue_light;

byte number_test_yellow = 0;
byte number_test_red = 0;
byte correct_data = 0;
//====================================================================================
//====================================================================================
void write_int_to_eeprom(int ny, int data) //Младший адрес и переменная
{
  byte temp = data;// младший байт;
  EEPROM.write(ny, temp);
  temp = data >> 8;
  EEPROM.write(ny + 1, temp);
}
//====================================================================================
//====================================================================================
int read_int_from_eeprom(int ny) //Младший адрес и переменная
{
  int  temp = EEPROM.read(ny + 1) << 8; //старший байт
  temp |= EEPROM.read(ny); //младший байт

  return temp ;
}

//====================================================================================
bool read_color_data_eeprom()
{
  correct_data = EEPROM.read(0);
  if (correct_data == 55)
  {
    Y_max_mass_red_light = EEPROM.read(1); //
    Y_min_mass_red_light = EEPROM.read(2); //
    Y_max_mass_green_light = EEPROM.read(3); //
    Y_min_mass_green_light = EEPROM.read(4); //
    Y_max_mass_blue_light = EEPROM.read(5); //
    Y_min_mass_blue_light = EEPROM.read(6); //

    R_max_mass_red_light = EEPROM.read(7); //
    R_min_mass_red_light = EEPROM.read(8); //
    R_max_mass_green_light = EEPROM.read(9); //
    R_min_mass_green_light = EEPROM.read(10); //
    R_max_mass_blue_light = EEPROM.read(11); //
    R_min_mass_blue_light = EEPROM.read(12); //
    number_test_yellow = 1;
    number_test_red = 1;
    Serial.print("Y_max_mass_red_light"); //
  Serial.println(Y_max_mass_red_light);
  Serial.print("Y_min_mass_red_light"); //
  Serial.println(Y_min_mass_red_light);
  Serial.print("Y_max_mass_green_light"); //
  Serial.println(Y_max_mass_green_light);
  Serial.print("Y_min_mass_green_light"); //
  Serial.println(Y_min_mass_green_light);
  Serial.print("Y_max_mass_blue_light"); //
  Serial.println(Y_max_mass_blue_light);
  Serial.print("Y_min_mass_blue_light"); //
  Serial.println(Y_min_mass_blue_light);

  Serial.print("R_max_mass_red_light"); //
  Serial.println(R_max_mass_red_light);
  Serial.print("R_min_mass_red_light"); //
  Serial.println(R_min_mass_red_light);
  Serial.print("R_max_mass_green_light"); //
  Serial.println(R_max_mass_green_light);
  Serial.print("R_min_mass_green_light"); //
  Serial.println(R_min_mass_green_light);
  Serial.print("R_max_mass_blue_light"); //
  Serial.println(R_max_mass_blue_light);
  Serial.print("R_min_mass_blue_light"); //
  Serial.println(R_min_mass_blue_light);
  
    Serial.println(" Data read ");
  }
  else   return false;
  return true;
}
//====================================================================================
//====================================================================================
//====================================================================================
void apds9960_setup()
{
  apds.init();
  apds.enableLightSensor(false);
  apds.setProximityGain(PGAIN_4X);
  apds.enableProximitySensor(false);
  read_color_data_eeprom();
}
//====================================================================================
//====================================================================================
void apds9960_read()
{
  apds.readAmbientLight(ambient_light);
  apds.readRedLight(red_light);
  apds.readGreenLight(green_light);
  apds.readBlueLight(blue_light) ;
  apds.readProximity(proximity_data);
  long mass = red_light + green_light + blue_light;
  mass_red_light = byte((long(red_light) * 100) / mass);
  mass_green_light = byte((long(green_light) * 100) / mass);
  mass_blue_light = byte((long(blue_light) * 100) / mass);
  Serial.println(mass_red_light);
  Serial.println(mass_green_light);
  Serial.println(mass_blue_light);
  Serial.println("//========================================");

}
//====================================================================================
//====================================================================================

bool write_color_data_eeprom()
{
  if (number_test_yellow > 0)
  {
    EEPROM.write(1, Y_max_mass_red_light); //
    delay(1);
    EEPROM.write(2, Y_min_mass_red_light); //
    delay(1);
    EEPROM.write(3, Y_max_mass_green_light); //
    delay(1);
    EEPROM.write(4, Y_min_mass_green_light); //
    delay(1);
    EEPROM.write(5, Y_max_mass_blue_light); //
    delay(1);
    EEPROM.write(6, Y_min_mass_blue_light); //
    delay(1);
    EEPROM.write(0, 55);
    delay(1);
    Serial.println(" Write Yellow ");
  }
  if (number_test_red > 0)
  {
    EEPROM.write(7, R_max_mass_red_light); //
    delay(1);
    EEPROM.write(8, R_min_mass_red_light); //
    delay(1);
    EEPROM.write(9, R_max_mass_green_light); //
    delay(1);
    EEPROM.write(10,  R_min_mass_green_light); //
    delay(1);
    EEPROM.write(11,  R_max_mass_blue_light); //
    delay(1);
    EEPROM.write(12,  R_min_mass_blue_light); //
    delay(1);
    EEPROM.write(0, 55);
    delay(1);
    Serial.println(" Write Red ");
  }
  EEPROM.write(13,  99); //

//  Serial.print("Y_max_mass_red_light"); //
//  Serial.println(Y_max_mass_red_light);
//  Serial.print("Y_min_mass_red_light"); //
//  Serial.println(Y_min_mass_red_light);
//  Serial.print("Y_max_mass_green_light"); //
//  Serial.println(Y_max_mass_green_light);
//  Serial.print("Y_min_mass_green_light"); //
//  Serial.println(Y_min_mass_green_light);
//  Serial.print("Y_max_mass_blue_light"); //
//  Serial.println(Y_max_mass_blue_light);
//  Serial.print("Y_min_mass_blue_light"); //
//  Serial.println(Y_min_mass_blue_light);
//
//  Serial.print("R_max_mass_red_light"); //
//  Serial.println(R_max_mass_red_light);
//  Serial.print("R_min_mass_red_light"); //
//  Serial.println(R_min_mass_red_light);
//  Serial.print("R_max_mass_green_light"); //
//  Serial.println(R_max_mass_green_light);
//  Serial.print("R_min_mass_green_light"); //
//  Serial.println(R_min_mass_green_light);
//  Serial.print("R_max_mass_blue_light"); //
//  Serial.println(R_max_mass_blue_light);
//  Serial.print("R_min_mass_blue_light"); //
//  Serial.println(R_min_mass_blue_light);
//  

}
//================================================
//Запоминает текущий цвет как желтый
bool foto_yellow()
{
  apds9960_read();
  //проверить расстояние
  // Serial.print("proximity_data = "); Serial.println(proximity_data);
 // if (proximity_data < 37) return false;
  if (number_test_yellow == 0)
  {
    Y_max_mass_red_light = Y_min_mass_red_light = mass_red_light;
    Y_max_mass_green_light = Y_min_mass_green_light = mass_green_light;
    Y_max_mass_blue_light = Y_min_mass_blue_light = mass_blue_light;
    number_test_yellow++;
  }
  else
  {
    if (Y_max_mass_red_light <  mass_red_light)  Y_max_mass_red_light =  mass_red_light;
    if (Y_min_mass_red_light > mass_red_light ) Y_min_mass_red_light = mass_red_light;

    if (Y_max_mass_green_light <  mass_green_light)  Y_max_mass_green_light =  mass_green_light;
    if (Y_min_mass_green_light > mass_green_light ) Y_min_mass_green_light = mass_green_light;

    if (Y_max_mass_blue_light <  mass_blue_light)  Y_max_mass_blue_light =  mass_blue_light;
    if (Y_min_mass_blue_light > mass_blue_light ) Y_min_mass_blue_light = mass_blue_light;
    number_test_yellow++;
  }
  Serial.println(" photo yellow ");
  return true;
}
//================================================
//================================================
//================================================
//Запоминает текущий цвет как красный
bool foto_red()
{
  apds9960_read();
  //проверить расстояние
  // Serial.print("proximity_data = "); Serial.println(proximity_data);
  //  if(proximity_data<37) return false;
  if (number_test_red == 0)
  {
    R_max_mass_red_light = R_min_mass_red_light = mass_red_light;
    R_max_mass_green_light = R_min_mass_green_light = mass_green_light;
    R_max_mass_blue_light = R_min_mass_blue_light = mass_blue_light;
    number_test_red++;
  }
  else
  {
    if (R_max_mass_red_light <  mass_red_light)  R_max_mass_red_light =  mass_red_light;
    if (R_min_mass_red_light > mass_red_light ) R_min_mass_red_light = mass_red_light;

    if (R_max_mass_green_light <  mass_green_light)  R_max_mass_green_light =  mass_green_light;
    if (R_min_mass_green_light > mass_green_light ) R_min_mass_green_light = mass_green_light;

    if (R_max_mass_blue_light <  mass_blue_light)  R_max_mass_blue_light =  mass_blue_light;
    if (R_min_mass_blue_light > mass_blue_light ) R_min_mass_blue_light = mass_blue_light;
    number_test_red++;
  }
  Serial.println(" photo red ");
  return true;
}


//================================================

bool test_red()
{
  apds9960_read();
  //вставить проверку расстояния
  //  Serial.print("proximity_data = "); Serial.println(proximity_data);
 // if (proximity_data < 37) return false;
  //  if (R_max_mass_red_light >=  mass_red_light)
  if (R_min_mass_red_light <= mass_red_light )
    if (R_max_mass_green_light >=  mass_green_light)
      //      if (R_min_mass_green_light <= mass_green_light )
      if (R_max_mass_blue_light >=  mass_blue_light)
        //        if (R_min_mass_blue_light <= mass_blue_light )
        return true;
  return false;
}
//================================================

bool test_yellow()
{
  apds9960_read();
 // if (proximity_data < 37) return false;
  //  if (R_max_mass_red_light >=  mass_red_light)
  if (R_min_mass_red_light <= mass_red_light )
    if (R_max_mass_green_light >=  mass_green_light)
      //      if (R_min_mass_green_light <= mass_green_light )
      if (R_max_mass_blue_light >=  mass_blue_light)
        //        if (R_min_mass_blue_light <= mass_blue_light )
        return false;
  return true;
  /*  apds9960_read();
    //вставить проверку расстояния
    // Serial.print("proximity_data = "); Serial.println(proximity_data);
    //  if(proximity_data<37) return false;
    // if (Y_max_mass_red_light >=  mass_red_light)
      if (Y_min_mass_red_light <= mass_red_light )
     //   if (Y_max_mass_green_light >=  mass_green_light)
          if (Y_min_mass_green_light <= mass_green_light )
            if (Y_max_mass_blue_light >=  mass_blue_light)
       //       if (Y_min_mass_blue_light <= mass_blue_light ) return true;
    return false;
  */
}

